chore(user/bkmml):Cleanup comment
[BK-2020-03.git] / unitproc / bkt-setTimeZoneEV
1 #!/bin/bash
2
3 # Desc: Set time zone environment variable TZ
4
5 yell() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370
6 die() { yell "$*"; exit 111; }
7 try() { "$@" || die "cannot $*"; }
8 setTimeZoneEV(){
9 # Desc: Set time zone environment variable TZ
10 # Usage: setTimeZoneEV arg1
11 # Version 0.1.3
12 # In : arg1: 'date'-compatible timezone string (ex: "America/New_York")
13 # TZDIR env var (optional; default: "/usr/share/zoneinfo")
14 # Out: exports TZ (env var)
15 # exit code 0 on success
16 # exit code 1 on incorrect number of arguments
17 # exit code 2 if unable to validate arg1
18 # Depends: bash 5.0.3, printenv 8.30, yell()
19 local tzDir returnState argTimeZone
20
21 argTimeZone="$1";
22 if ! [[ $# -eq 1 ]]; then
23 yell "ERROR:Invalid argument count.";
24 return 1;
25 fi;
26
27 # Read TZDIR env var if available
28 if printenv TZDIR 1>/dev/null 2>&1; then
29 tzDir="$(printenv TZDIR)";
30 else
31 tzDir="/usr/share/zoneinfo";
32 fi;
33
34 # Validate TZ string
35 if ! [[ -f "$tzDir"/"$argTimeZone" ]]; then
36 yell "ERROR:Invalid time zone argument.";
37 return 2;
38 else
39 # Export ARG1 as TZ environment variable
40 TZ="$argTimeZone" && export TZ && returnState="true";
41 fi;
42
43 # Determine function return code
44 if [ "$returnState" = "true" ]; then
45 return 0;
46 fi;
47 } # Exports TZ environment variable
48
49 #==BEGIN sample code==
50 date --iso-8601=seconds; echo "==============="; sleep 2
51
52 date --iso-8601=seconds
53 cmd1="setTimeZoneEV America/New_York"
54 echo "Running:$cmd1"; $cmd1; echo "Exit code:$?"
55 date --iso-8601=seconds; echo "==============="; sleep 2
56
57 date --iso-8601=seconds
58 cmd2="setTimeZoneEV Asia/Tokyo"
59 echo "Running:$cmd2"; $cmd2; echo "Exit code:$?"
60 date --iso-8601=seconds; echo "==============="; sleep 2
61
62 date --iso-8601=seconds
63 cmd3="setTimeZoneEV";
64 echo "Running:$cmd3"; $cmd3; echo "Exit code:$?"
65 date --iso-8601=seconds; echo "==============="; sleep 2
66
67 date --iso-8601=seconds
68 cmd4="setTimeZoneEV Pacific/Lemuria"
69 echo "Running:$cmd4"; $cmd4; echo "Exit code:$?"
70 date --iso-8601=seconds; echo "==============="; sleep 2
71
72 try setTimeZoneEV Atlantic/Atlantis
73 #==END sample code==
74
75 # Author: Steven Baltakatei Sandoval
76 # License: GPLv3+
77
78